/* code03e9.c - SysUIAppSwitch handler
	Copyright  2000 by Mitch Blevins
	Distributed under the GNU GPL.
	Based on LinkHistoryHack by Ben Darnell <bgdarnel@unity.ncsu.edu>
	which was based on...
	Based on SampleHack by Roger Chaplin <foursquaredev@att.net>
*/

#include <Pilot.h>
#include <FeatureMgr.h>

#include "eTask.h"
#include "eTaskRsc.h"

// Err MySysAppLaunch(UInt cardNo, LocalID dbID, UInt launchFlags, Word cmd, Ptr cmdPBP, DWord *resultP)
Err MySysUIAppSwitch(UInt cardNo, LocalID dbID, Word cmd, Ptr cmdPBP)
{
//	Err (*oldTrap)(UInt, LocalID, UInt, Word, Ptr, DWordPtr);
	Err (*oldTrap)(UInt, LocalID, Word, Ptr);
	DWord addrValue;
	ULong dbType;
	DWord dbCreator;
	Char dbName[dmDBNameLength];
	ListStats listStats;
	TaskList taskList = NULL;
	Word prefsSize;
	DmOpenRef dbRef;
	Int resIndex, i, nTotalItems;
	VoidHand hIcon;
	SWord swResult;
	Boolean bFound = false;
	
	// Get the address of the old SysUIAppSwitch() from HackMaster
	FtrGet(CreatorID, 0x3e9, &addrValue);
	// Set the function pointer to the old trap
	oldTrap = (Err(*)(UInt, LocalID, Word, Ptr))addrValue;

//	if (launchFlags & sysAppLaunchFlagNewGlobals) {
		// Find the creatorID, type and name
		if (DmDatabaseInfo(cardNo, dbID, dbName, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &dbType, &dbCreator)) goto allDone;
		// Ignore it if it is not an application
		if (dbType != sysFileTApplication) goto allDone;
		
		prefsSize = sizeof(ListStats);
		swResult = PrefGetAppPreferences(CreatorID, idListStats, &listStats, &prefsSize, true);
		
		if ((swResult==noPreferenceFound) || (prefsSize!=sizeof(ListStats))) {
			nTotalItems = listStats.nExecuted = listStats.nFavorite = listStats.nIgnored = 0;
			listStats.showIcon = 1;
		}
		else {
			nTotalItems = listStats.nExecuted+listStats.nFavorite+listStats.nIgnored;
			
			prefsSize = 0;
			swResult = PrefGetAppPreferences(CreatorID, idTaskList, NULL, &prefsSize, true);
			
			if ((swResult==noPreferenceFound) || (prefsSize!=nTotalItems*sizeof(TaskItem))) {
				nTotalItems = listStats.nExecuted = listStats.nFavorite = listStats.nIgnored = 0;
				listStats.showIcon = 1;
			}
			else {
				taskList = MemPtrNew((nTotalItems+1)*sizeof(TaskItem));	// one more
				PrefGetAppPreferences(CreatorID, idTaskList, taskList+1, &prefsSize, true);	// shift one
		
				// Look up the task_list
				for (i=nTotalItems; i>0; i--) {
					if (taskList[i].creator == dbCreator) {
						MemMove(taskList, taskList+i, sizeof(TaskItem));
						
						bFound = true;
						break;
					}
				}
			}
		}
		
		if (taskList == NULL) taskList = MemPtrNew(sizeof(TaskItem));
		
		// Hit or Miss
		if (bFound == false) {
			taskList[0].creator = dbCreator;
			StrCopy(taskList[0].name, dbName);
			taskList[0].width = FntCharsWidth(dbName, StrLen(dbName));
			taskList[0].flag = IS_REFERENCED;
	
/*			MemSet(taskList[0].icon, ICON_SIZE, 0);
			
		   taskList[0].icon[1]=0x0f; taskList[0].icon[3]=0x09; taskList[0].icon[5]=0x02;
		   taskList[0].icon[16]=0x01; taskList[0].icon[18]=0x0e; taskList[0].icon[19]=0xe0;
		   taskList[0].icon[20]=0x0c; taskList[0].icon[21]=0x60; taskList[0].icon[22]=0x08;
		   taskList[0].icon[23]=0x20; taskList[0].icon[24]=0x10; taskList[0].icon[25]=0x10;
		   taskList[0].icon[26]=0x08; taskList[0].icon[27]=0x20; taskList[0].icon[28]=0x0c;
		   taskList[0].icon[29]=0x60; taskList[0].icon[30]=0x0e; taskList[0].icon[31]=0xe0;
		   taskList[0].icon[32]=0x01;
*/
			// Get the application's small icon image
			dbRef = DmOpenDatabase(cardNo, dbID, dmModeReadOnly);
			if (dbRef != 0) {
				resIndex = DmFindResource(dbRef, 'tAIB', 1001, NULL);
				if (resIndex != -1) {
					hIcon = DmGetResourceIndex(dbRef, resIndex);
				}
				else {
					DmCloseDatabase(dbRef);
					dbRef = DmOpenDatabaseByTypeCreator('HACK', CreatorID, dmModeReadOnly);

					hIcon = DmGet1Resource('Tbmp', btmDefault);
				}

				MemMove(taskList[0].icon, (BitmapPtr)MemHandleLock(hIcon), ICON_SIZE);
				
				MemHandleUnlock(hIcon);
				DmReleaseResource(hIcon);
	
				DmCloseDatabase(dbRef);
			}
			else
				goto cleanUp;
		}
		else if (taskList[0].flag == IS_IGNORED) {
			switch (dbCreator) {
				case 'lnch':
				case 'LcPd':
				case 'SSle':
				case 'ApMn':
				case 'MjBb':
				case 'Cmdr':
				case 'PApL':
				case 'QkLn':
				case 'Lnch':
				case 'CoLn':
				case 'StBr':
					goto cleanUp;
			}
		}
		
		// first, unconditional increment
		listStats.nExecuted++;
		nTotalItems++;
				
		// Remove redunduncy in task_list
		for (i=1; i<listStats.nExecuted; i++) {
			if (taskList[i].creator == taskList[0].creator) {
				MemMove(taskList+i, taskList+i+1, (nTotalItems-i-1)*sizeof(TaskItem));
				
				listStats.nExecuted--;
				nTotalItems--;
				break;
			}
		}

		// Don't cache for favirite or ignored app.
		if (listStats.nExecuted > 2) {
			if (taskList[2].flag != IS_REFERENCED) {
				MemMove(taskList+2, taskList+3, (nTotalItems-3)*sizeof(TaskItem));
				
				listStats.nExecuted--;
				nTotalItems--;
			}
		}
				
		// Limit the size of task_list
		if (listStats.nExecuted+listStats.nFavorite > NUM_ITEMS) {
			MemMove(taskList+listStats.nExecuted-1, taskList+listStats.nExecuted, (nTotalItems-listStats.nExecuted)*sizeof(TaskItem));
			
			listStats.nExecuted--;
			nTotalItems--;
		}
		
		PrefSetAppPreferences(CreatorID, idTaskList, 0, taskList, nTotalItems*sizeof(TaskItem), true);
		PrefSetAppPreferences(CreatorID, idListStats, 0, &listStats, sizeof(ListStats), true);

cleanUp:
		if (taskList != NULL) MemPtrFree(taskList);
//	}

allDone:
//	return oldTrap(cardNo, dbID, launchFlags, cmd, cmdPBP, resultP);
	return oldTrap(cardNo, dbID, cmd, cmdPBP);
}